// EcoModeler - C# Edition :: Version 9.17 build 3378
using System;
using System.ComponentModel;
using System.Collections;
using System.Collections.Generic;
using Eco.Services;
using Eco.ObjectRepresentation;
using Eco.ObjectImplementation;
using Eco.UmlRt;
using Eco.UmlCodeAttributes;
using Eco.Subscription;

namespace ECO_ORMBattle_SimpleExample.Model
{
	#region MM_ECO_Generated
	#region Attributes
	[UmlElement(Id="{42fa63b2-4b8d-4246-bed4-e59bf58a6c5d}")]
	[UmlTaggedValue("Eco.DefaultStringRepresentation", "self.Reference")]
	[StateMachine("Invoice", "<?xml version=\"1.0\" encoding=\"utf-16\"?><StateMachine xmlns:xsd=\"http://www." +
		"w3.org/2001/XMLSchema\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance" +
		"\" Name=\"Invoice\" StateAttribute=\"InvoiceState\"><Transitions><Transition Sou" +
		"rce=\"Initial_1\" Target=\"Raised\" Guard=\"\" Trigger=\"\" Effect=\"\"/><Transition " +
		"Source=\"Raised\" Target=\"Confirmed\" Guard=\"\" Trigger=\"ConfirmInvoice\" Effect" +
		"=\"\"/><Transition Source=\"Raised\" Target=\"Cancelled\" Guard=\"\" Trigger=\"Cance" +
		"lInvoice\" Effect=\"\"/><Transition Source=\"Confirmed\" Target=\"Dispatched\" Gua" +
		"rd=\"self.Total &lt; 500\" Trigger=\"DispatchInvoice\" Effect=\"\"/><Transition S" +
		"ource=\"Confirmed\" Target=\"Review\" Guard=\"self.Total &gt;= 500\" Trigger=\"Rev" +
		"iewInvoice\" Effect=\"\"/><Transition Source=\"Review\" Target=\"Dispatched\" Guar" +
		"d=\"\" Trigger=\"DispatchInvoice\" Effect=\"\"/><Transition Source=\"Dispatched\" T" +
		"arget=\"Settled\" Guard=\"\" Trigger=\"InvoiceSettled\" Effect=\"\"/><Transition So" +
		"urce=\"Review\" Target=\"Cancelled\" Guard=\"\" Trigger=\"CancelInvoice\" Effect=\"\"" +
		"/></Transitions><Vertexes><Vertex Name=\"Initial_1\" Kind=\"InitialState\" Entr" +
		"y=\"\" Exit=\"\" Representation=\"\"><Regions/></Vertex><Vertex Name=\"Raised\" Kin" +
		"d=\"RegularState\" Entry=\"\" Exit=\"\" Representation=\"\"><Regions/></Vertex><Ver" +
		"tex Name=\"Cancelled\" Kind=\"RegularState\" Entry=\"\" Exit=\"\" Representation=\"\"" +
		"><Regions/></Vertex><Vertex Name=\"Confirmed\" Kind=\"RegularState\" Entry=\"\" E" +
		"xit=\"\" Representation=\"\"><Regions/></Vertex><Vertex Name=\"Dispatched\" Kind=" +
		"\"RegularState\" Entry=\"\" Exit=\"\" Representation=\"\"><Regions/></Vertex><Verte" +
		"x Name=\"Review\" Kind=\"RegularState\" Entry=\"\" Exit=\"\" Representation=\"\"><Reg" +
		"ions/></Vertex><Vertex Name=\"Settled\" Kind=\"RegularState\" Entry=\"\" Exit=\"\" " +
		"Representation=\"\"><Regions/></Vertex></Vertexes></StateMachine>")]
	#endregion

	#endregion
	public class Invoice: object, ILoopBack
	{
		#region MM_ECO AutoGenerated ECO code

		protected IContent eco_Content;

		IObject IObjectProvider.AsIObject()
		{
			return this.eco_Content.AsIObject();
		}

		public IObjectInstance AsIObject()
		{
			return this.eco_Content.AsIObject();
		}

		public struct Eco_LoopbackIndices
		{
			public const int Eco_FirstMember = 0;
			public const int Eco_MemberCount = (Eco_FirstMember + 7);
			public const int Customer_MemberIndex = Eco_FirstMember + 0;
			public const int InvoiceState_MemberIndex = Eco_FirstMember + 1;
			public const int Products_MemberIndex = Eco_FirstMember + 2;
			public const int InvoiceProducts_MemberIndex = Eco_FirstMember + 3;
			public const int Reference_MemberIndex = Eco_FirstMember + 4;
			public const int Total_MemberIndex = Eco_FirstMember + 5;
			public const int VatTotal_MemberIndex = Eco_FirstMember + 6;
		}

		public virtual object get_MemberByIndex(int index)
		{
			switch (index)
			{
				case Eco_LoopbackIndices.Total_MemberIndex: return this.Total;
				case Eco_LoopbackIndices.VatTotal_MemberIndex: return this.VatTotal;
				default: throw new System.IndexOutOfRangeException();
			}
		}

		public virtual void set_MemberByIndex(int index, object value)
		{
			switch (index)
			{
				default: throw new System.IndexOutOfRangeException();
			}
		}

		protected void Initialize(IEcoServiceProvider serviceProvider)
		{
			if ((this.eco_Content == null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				this.eco_Content = factory.CreateContent(this);
				this.eco_Content.LoopbackValid();
			}
		}

		protected void Deinitialize(IEcoServiceProvider serviceProvider)
		{
			if ((this.eco_Content != null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				factory.CreateContentFailed(this.eco_Content, this);
				this.eco_Content = null;
			}
		}

		public IEcoList<InvoiceProducts> InvoiceProducts
		{
			get
			{
				return new ObjectListAdapter<InvoiceProducts>((IList) (this.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.InvoiceProducts_MemberIndex)));
			}
		}

		[UmlElement(Id="{f034ef6f-c5f0-46fc-8a40-b91a175824c3}")]
		[UmlTaggedValue("Eco.IsTrigger", "True")]
		public void CancelInvoice()
		{
			this.AsIObject().Invoke("CancelInvoice", new object[] {});
		}

		[UmlElement(Id="{5b2babfb-28ae-4e42-9f1a-11cf04c37df1}")]
		[UmlTaggedValue("Eco.IsTrigger", "True")]
		public void ConfirmInvoice()
		{
			this.AsIObject().Invoke("ConfirmInvoice", new object[] {});
		}

		[UmlElement(Id="{5d465463-4370-4fff-89bd-ac7fb2a803b6}")]
		[UmlTaggedValue("Eco.IsTrigger", "True")]
		public void DispatchInvoice()
		{
			this.AsIObject().Invoke("DispatchInvoice", new object[] {});
		}

		[UmlElement(Id="{06a287b8-090d-46b1-a852-787649066b87}")]
		[UmlTaggedValue("Eco.IsTrigger", "True")]
		public void InvoiceSettled()
		{
			this.AsIObject().Invoke("InvoiceSettled", new object[] {});
		}

		[UmlElement(Id="{08c14936-b35b-4516-bb70-80205d62aec2}")]
		[UmlTaggedValue("Eco.IsTrigger", "True")]
		public void ReviewInvoice()
		{
			this.AsIObject().Invoke("ReviewInvoice", new object[] {});
		}
		#endregion

		#region MM_ECO Model owned attributes
		//Note: Do not remove any property within this region, nor change its signature

		#region MM_ECO_Generated
		[UmlElement("AssociationEnd", Index=(Invoice.Eco_LoopbackIndices.Customer_MemberIndex), Id="{f564b6cb-25c3-46c5-83b2-af7b2f617722}")]
		[UmlMetaAttribute("association", typeof(ORMBattle_SimpleExamplePackage.CustomerInvoices), Index=1)]
		[UmlMetaAttribute("multiplicity", "1")]
		[UmlTaggedValue("Eco.Embed", "True")]
		#endregion
		public ECO_ORMBattle_SimpleExample.Model.Customer Customer
		{
			get
			{
				#region MM_ECO_Generated
				return (ECO_ORMBattle_SimpleExample.Model.Customer) (this.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.Customer_MemberIndex));
				#endregion
			}
			set
			{
				#region MM_ECO_Generated
				this.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.Customer_MemberIndex, ((object)(value)));
				#endregion
			}
		}

		#region MM_ECO_Generated
		#region Attributes
		[UmlElement(Index=(Invoice.Eco_LoopbackIndices.InvoiceState_MemberIndex), Id="{319ccd51-7a26-4ddf-af6d-1a13e0d04a0d}")]
		[UmlTaggedValue("Eco.AllowNULL", "True")]
		[UmlTaggedValue("Eco.Length", "255")]
		[UmlTaggedValue("Eco.IsStateAttribute", "True")]
		#endregion

		#endregion
		public string InvoiceState
		{
			get
			{
				#region MM_ECO_Generated
				return (string) (this.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.InvoiceState_MemberIndex));
				#endregion
			}
		}

		#region MM_ECO_Generated
		[UmlElement("AssociationEnd", Index=(Invoice.Eco_LoopbackIndices.Products_MemberIndex), Id="{9f9f70d4-595b-4d51-8462-486c412115cf}")]
		[UmlMetaAttribute("association", typeof(ORMBattle_SimpleExamplePackage.InvoiceProducts), Index=1)]
		[UmlMetaAttribute("multiplicity", "0..*")]
		[UmlTaggedValue("Eco.Embed", "False")]
		#endregion
		public IEcoList<Product> Products
		{
			get
			{
				#region MM_ECO_Generated
				return new ObjectListAdapter<Product>((IList) (this.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.Products_MemberIndex)));
				#endregion
			}
		}

		#region MM_ECO_Generated
		#region Attributes
		[UmlElement(Index=(Invoice.Eco_LoopbackIndices.Total_MemberIndex), Id="{38d689f1-1f31-4af5-892e-3d0aae022ea0}")]
		[UmlTaggedValue("persistence", "transient")]
		[UmlTaggedValue("derived", "True")]
		[UmlTaggedValue("Eco.Length", "255")]
		[UmlTaggedValue("Eco.HasUserCode", "True")]
		#endregion

		#endregion
		public decimal Total
		{
			get
			{
				#region MM_ECO_Generated
				return (decimal) (this.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.Total_MemberIndex));
				#endregion
			}
		}

		#region MM_ECO_Generated
		#region Attributes
		[UmlElement(Index=(Invoice.Eco_LoopbackIndices.VatTotal_MemberIndex), Id="{89e26f05-754c-499a-b18b-6f96eabb00a3}")]
		[UmlTaggedValue("persistence", "transient")]
		[UmlTaggedValue("derived", "True")]
		[UmlTaggedValue("Eco.Length", "255")]
		[UmlTaggedValue("Eco.HasUserCode", "True")]
		#endregion

		#endregion
		public decimal VatTotal
		{
			get
			{
				#region MM_ECO_Generated
				return (decimal) (this.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.VatTotal_MemberIndex));
				#endregion
			}
		}


		#region MM_ECO_Generated
		#region Attributes
		[UmlElement(Index=(Invoice.Eco_LoopbackIndices.Reference_MemberIndex), Id="{e9148342-542c-458c-88e9-12cff55a00f9}")]
		[UmlTaggedValue("Eco.Length", "255")]
		#endregion

		#endregion
		public string Reference
		{
			get
			{
				#region MM_ECO_Generated
				return (string) (this.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.Reference_MemberIndex));
				#endregion
			}
			set
			{
				#region MM_ECO_Generated
				this.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.Reference_MemberIndex, ((object)(value)));
				#endregion
			}
		}
		#endregion

		#region MM_ECO Model owned methods
		//Note: Do not remove any method within this region, nor change its signature

		public Invoice(IContent content)
		{
			#region MM_ECO_Generated
			this.eco_Content = content;
			content.AssertLoopbackUnassigned();
			#endregion
		}

		public Invoice(IEcoServiceProvider serviceProvider)
		{
			this.Initialize(serviceProvider);
			try
			{
				// Place user code ONLY here
			}
			catch (System.Exception)
			{
				this.Deinitialize(serviceProvider);
				throw;
			}
		}

		#region MM_ECO_Generated
		#region Attributes
		[UmlElement(Id="{f52a5234-d8e6-4464-a552-aee41e035c06}")]
		#endregion

		#endregion
		public decimal TotalDerive()
		{
            // Here we want to add up the cost of all Products involved in this invoice
            decimal sumTotal = decimal.Zero;

            foreach (InvoiceProducts invProd in this.InvoiceProducts)
            {
                if (invProd != null)
                {
                    // Calculate this lines Sub-Total and VAT
                    if (invProd.Products != null)
                    {
                        if (invProd.Products.VATRate != null)
                        {
                            decimal lineSubTotal = invProd.Quantity * invProd.Products.Price;
                            sumTotal += lineSubTotal;
                        }
                    }
                }
            }

            return sumTotal;
		}

// TODO: removed member
// 		#region MM_ECO_Generated
// 		#region Attributes
// 		[UmlElement(Id="{d422c70e-dfae-405d-aef8-7e202fcc8bd5}")]
// 		#endregion
// 
// 		#endregion
// 		public decimal VatTotalDerive()
// 		{
//             // Here we want to add up the cost of all the VAT involved with this invoice
//             if (VatTotal == 0)
//             {
//                 decimal sumVat = decimal.Zero;
// 
//                 foreach (InvoiceProducts invProd in this.InvoiceProducts)
//                 {
//                     if (invProd != null)
//                     {
//                         if (invProd.Products != null)
//                         {
//                             if (invProd.Products.VATRate != null)
//                             {
//                                 decimal lineSubTotal = invProd.Quantity * invProd.Products.Price;
//                                 decimal lineVat = lineSubTotal * invProd.Products.VATRate.Rate;
// 
//                                 sumVat += lineVat;
//                             }
//                         }
//                     }
//                 }
// 
//                 VatTotal = sumVat;
//             }
// 
//             return VatTotal;
// 		}

		#region MM_ECO_Generated
		#region Attributes
		[UmlElement(Id="{cca878ea-0bca-4e22-b01c-a75765546f5d}")]
		#endregion

		#endregion
		protected void SendEmail()
		{
            // Here we might want to send an email for some reason or other, and react to it
            switch (InvoiceState)
            {
                case "Confirmed":
                case "Dispatched":
                    {
                        // In these instances we want to notify the customer that the state
                        // of this invoice has changed.

                        break;
                    }

                default:
                    {
                        // We aren't interested in other situations
                        break;
                    }
            }
		}

		#region MM_ECO_Generated
		#region Attributes
		[UmlElement(Id="{4c7b2f78-7639-4835-95cc-427bb832ed6c}")]
		#endregion

		#endregion
		public decimal VatTotalDerive()
		{
            // Here we want to add up the cost of all the VAT involved with this invoice
            decimal sumVat = decimal.Zero;

            foreach (InvoiceProducts invProd in this.InvoiceProducts)
            {
                if (invProd != null)
                {
                    if (invProd.Products != null)
                    {
                        if (invProd.Products.VATRate != null)
                        {
                            decimal lineSubTotal = invProd.Quantity * invProd.Products.Price;
                            decimal lineVat = lineSubTotal * invProd.Products.VATRate.Rate;

                            sumVat += lineVat;
                        }
                    }
                }
            }

            return sumVat;
        }
		#endregion
	}
}
