using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Eco.Handles;
using Eco.Windows.Forms;
using Eco.WinForm;
using Eco.ObjectRepresentation;
using Eco.Services;

namespace ECO_ORMBattle_SimpleExample
{
    /// <summary>
    /// Summary description for ManageVatRates.
    /// </summary>
    public partial class ManageVatRates : System.Windows.Forms.Form
    {

        public ManageVatRates(ECO_ORMBattle_SimpleExample.ECO_ORMBattle_SimpleExampleEcoSpace ecoSpace)
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            // Set EcoSpace (actually stores it in rhRoot.EcoSpace)
            // Note that you need to set the EcoSpace property for 
            // each ReferenceHandle and VariableHandle you add to 
            // the form.
            rhRoot.EcoSpace = ecoSpace;
        }

        public ECO_ORMBattle_SimpleExample.ECO_ORMBattle_SimpleExampleEcoSpace EcoSpace
        {
            get { return (ECO_ORMBattle_SimpleExample.ECO_ORMBattle_SimpleExampleEcoSpace)rhRoot.EcoSpace; }
        }

        private void ManageVatRates_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (EcoSpace.DirtyList.HasDirtyObjects())
                EcoSpace.UpdateDatabase();
        }
    }
}
